package com.huigou.topsun.sap.purchaseOrder.controller;

import com.huigou.topsun.sap.purchaseOrder.application.SapPurchaseOrderItemApplication;
import com.huigou.topsun.sap.purchaseOrder.domain.query.SapPurchaseOrderItemQueryRequest;
import com.huigou.topsun.sap.purchaseOrder.repository.SapPurchaseOrderItemRepository;
import com.huigou.uasp.annotation.ControllerMapping;
import com.huigou.uasp.client.CommonController;
import com.huigou.util.SDO;
import org.springframework.stereotype.Controller;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 * @Auther: xin.lu
 * @Date: 2023/12/27/17:24
 * @Description:
 */
@Controller
@ControllerMapping("/sapPurchaseOrderItem")
public class SapPurchaseOrderItemController extends CommonController {
    @Resource
    private SapPurchaseOrderItemApplication sapPurchaseOrderItemApplication;
    @Resource
    private SapPurchaseOrderItemRepository sapPurchaseOrderItemRepository;

    public String querySapPurchaseOrderItems(){
        SDO sdo = this.getSDO();
        SapPurchaseOrderItemQueryRequest queryRequest = sdo.toQueryRequest(SapPurchaseOrderItemQueryRequest.class);
        Map<String, Object> map = sapPurchaseOrderItemApplication.querySapPurchaseOrderItems(queryRequest);
        return toResult(map);
    }

    public String deleteSapPurchaseOrderItem(){
        SDO sdo = this.getSDO();
        List<String> ids = sdo.getIds();
        sapPurchaseOrderItemApplication.deleteByIds(ids);
        return success();
    }

}
